main.fun = function(y.val, w.val, x.val, y.main, w.main, x.main, beta.tilde, h.beta, a.tau, b.tau, xi, kappa, a.sig, g.sig, h.sig, delta, Kmax, bet, tau, omega, z, nk, k, b.sig, priorK, lpois, AssumeScene)  

# main function implementing measurement error model of 
{

n.val=length(y.val); n.main=length(y.main); n=n.val+n.main
y=c(y.val, y.main); w=c(w.val, w.main); x=c(x.val, x.main)

for(iter in 1:T) {

# update beta
bet = update.Beta(y, x, bet, h.beta, beta.tilde)


# update each y_i in validation set, i=1,...,n.val
eta = bet[1]+bet[2]*x.val; py = exp(eta)/(1+exp(eta))
y.val = rbinom(n.val,1,py)
y = c(y.val, y.main)


# update tau
tau = update.Tau(y, w, x, tau, a.tau, b.tau, AssumeScene)


# update each x_i, i=1,...,n.main, using random walk Metropolis
x.main = update.X(y.main, w.main, x.main, bet, tau, z, mu, sigma2, AssumeScene)
x=c(x.val, x.main)


# update omega, mu, sigma2, b.sig, z 
upd.omsbc = update.OMuSigBC(k, z, nk, n, x, omega, mu, sigma2, kappa, xi, a.sig, g.sig, h.sig, b.sig, delta)  
omega=upd.omsbc$omega; mu=upd.omsbc$mu; sigma2=upd.omsbc$sigma2;
b.sig=upd.omsbc$b.sig; z=upd.omsbc$z; nk=upd.omsbc$nk


# update K and mixture parameters using RJMCMC
upd.ksm = rjmcmcSM(omega, mu, sigma2, z, x, nk, k, Kmax, delta, a.sig, b.sig, kappa, xi, priorK, lpois) 
omega=upd.ksm$omega; mu=upd.ksm$mu; sigma2=upd.ksm$sigma2; z=upd.ksm$z; k=upd.ksm$k; nk=upd.ksm$nk


# create/delete empty components using RJMCMC
upd.kbd = rjmcmcBD(omega, mu, sigma2, z, nk, k, Kmax, delta, priorK, lpois) 
omega=upd.kbd$omega; mu=upd.kbd$mu; sigma2=upd.kbd$sigma2; z=upd.kbd$z; k=upd.kbd$k; nk=upd.kbd$nk

# log-posterior probability of visited model

log.lik.all = logLik(y, w, x, bet, tau, z, nk, mu, sigma2, omega, AssumeScene) 
log.param = sum(dnorm(mu, xi, sqrt(1/kappa), log=T)) + 
	sum(dgamma(1/sigma2, a.sig, b.sig, log=T)) + logddir(omega, rep(delta,k)) + 	dmvnorm(bet, beta.tilde, h.beta, log=T) + 
	sum(dgamma(tau, a.tau, b.tau, log=T)) + dgamma(b.sig, g.sig, h.sig, log=T)

if(priorK==1) {
	logkpr = -log(Kmax-1)
}  else  {
	logkpr = dpois(k,lpois,log=T) - log(ppois(Kmax,lpois)-dpois(0,lpois))
}

LogPost[iter] = logkpr + log.param + log.lik.all 
	

X[iter,]=x.main; Y[iter,]=y.val; Z[iter,]=z; 
Beta[iter,] = bet; Tau[iter,]=tau; Bsig[iter]=b.sig;
K[iter,]=c(k, length(which(nk>0)), length(which(nk==0))); 
Nk[[iter]]=nk; Omega[[iter]]=omega; Mu[[iter]]=mu; Sigma2[[iter]]=sigma2
}

return( list(Beta=Beta, Tau=Tau, X=X, Y=Y, Z=Z, K=K, Nk=Nk, Omega=Omega, Mu=Mu, Sigma2=Sigma2, Bsig=Bsig, LogPost=LogPost))
}

