rjmcmcSM = function(omega, mu, sigma2, z, x.main, nk, k, Kmax, delta, a.sig, b.sig, kappa, xi, priorK, lpois) 

{

# Split/Merge move
if(k==1)   {  # can only split
	choose.sm = 1; p.birth=1; p.death=0 ; prob.sm=0.5 	
}	else if(k==Kmax)  {   # can only merge
	choose.sm = 2; p.birth=0; p.death=1; prob.sm=0.5 	
}	else  { 
	choose.sm = sample(1:2, 1); p.birth = p.death = 0.5; 
	if((k==2 & choose.sm==2) | (k==Kmax-1 & choose.sm==1))  { prob.sm = 2 }  else {  prob.sm = 1  }
}


if(choose.sm==1)   {			# choose Split move
	sel1=which(nk>0)
	if(length(sel1)==1) { j=sel1 } else  { j=sample(sel1, 1) }
	
	# if(k==1) {j=1}  else {  j=sample(1:k, 1) }

	u1=rbeta(1,2,2); u2=rbeta(1,2,2); u3=rbeta(1,1,1)
	omega1 = omega[j]*u1;  omega2 = omega[j]*(1-u1)
	mu1 = mu[j]-u2*sqrt(sigma2[j]*omega2/omega1)
	mu2 = mu[j]+u2*sqrt(sigma2[j]*omega1/omega2)
	sig1 = u3*(1-u2^2)*sigma2[j]*omega[j]/omega1
	sig2 = (1-u3)*(1-u2^2)*sigma2[j]*omega[j]/omega2
	
	if(mu1 < mu2)  { 
		omega.j1=omega1; omega.j2=omega2;
		mu.j1=mu1; mu.j2=mu2; sigma2.j1=sig1; sigma2.j2=sig2
	} 	else {
		omega.j1=omega2; omega.j2=omega1;
		mu.j1=mu2; mu.j2=mu1; sigma2.j1=sig2; sigma2.j2=sig1
	}

	if( k==1 | sum(mu[-j] > mu.j1 & mu[-j] < mu.j2)==0)  {
		sel = which(z==j); pci.j=ci.j=rep(0,length(sel)); log.palloc=0
		for(i in 1:length(sel) ) {
			pci.j1 = omega.j1*dnorm(x.main[sel[i]], mu.j1, sqrt(sigma2.j1))
			pci.j2 = omega.j2*dnorm(x.main[sel[i]], mu.j2, sqrt(sigma2.j2))
			pci.j[i] = pci.j2/sum(pci.j1, pci.j2) 
		}

		if( sum(is.na(pci.j))==0 ) {
			for(i in 1:length(sel)) {
				ci.j[i] = rbinom(1,1,pci.j[i])
				log.palloc = log.palloc+dbinom(ci.j[i],1, prob=pci.j[i], log=T)	}
		n.j=clusize(ci.j+1,2)
	
		if(j==1 & k==1) {
			omega.prop=c(omega.j1, omega.j2)
			mu.prop=c(mu.j1, mu.j2)
			sigma2.prop=c(sigma2.j1, sigma2.j2)
			z.prop=z[z==j]+ci.j; k.prop=k+1; nk.prop=n.j
		} else if(j==1) {
			omega.prop=c(omega.j1, omega.j2, omega[(j+1):k])
			mu.prop=c(mu.j1, mu.j2, mu[(j+1):k])
			sigma2.prop=c(sigma2.j1, sigma2.j2, sigma2[(j+1):k])
			z.prop=z; z.prop[z==j]=z[z==j]+ci.j; z.prop[z>j]=z[z>j]+1; k.prop=k+1
			nk.prop=c(n.j,nk[(j+1):k])
		} else if(j==k)  {
			omega.prop=c(omega[1:(j-1)], omega.j1, omega.j2)
			mu.prop=c(mu[1:(j-1)], mu.j1, mu.j2)
			sigma2.prop=c(sigma2[1:(j-1)], sigma2.j1, sigma2.j2)
			z.prop=z; z.prop[z==j]=z[z==j]+ci.j; k.prop=k+1
			nk.prop=c(nk[1:(j-1)], n.j)
		} else  {
		  	omega.prop=c(omega[1:(j-1)], omega.j1, omega.j2, omega[(j+1):k])
			mu.prop = c(mu[1:(j-1)], mu.j1, mu.j2, mu[(j+1):k])
			sigma2.prop = c(sigma2[1:(j-1)], sigma2.j1, sigma2.j2, sigma2[(j+1):k])
			z.prop=z; z.prop[z==j]=z[z==j]+ci.j; z.prop[z>j]=z[z>j]+1; k.prop=k+1
			nk.prop=c(nk[1:(j-1)], n.j, nk[(j+1):k])
		}


		x.sel = x.main[sel]; 

		loglik.pre = dmvnorm(x.sel, rep(mu[j],nk[j]), sigma2[j]*diag(nk[j]), log=T)
		if(max(n.j) < nk[j]) {
			loglik.prop = dmvnorm(x.sel[ci.j==0], rep(mu.j1, n.j[1]), sigma2.j1*diag(n.j[1]), log=T) 
				+ dmvnorm(x.sel[ci.j==1], rep(mu.j2, n.j[2]), sigma2.j2*diag(n.j[2]), log=T) 
		} else {  	loglik.prop = loglik.pre	}

		logterm.omega = (delta-1+n.j[1])*log(omega.j1)+(delta-1+n.j[2])*log(omega.j2)
			-(delta-1+nk[j])*log(omega[j])-log(beta(delta, k*delta))
		logterm.mu = 1/2*(log(kappa)-log(2*pi)) - 1/2*kappa*((mu.j1-xi)^2+(mu.j2-xi)^2-(mu[j]-xi)^2)
		logterm.sigma = a.sig*log(b.sig)-lgamma(a.sig)-(a.sig+1)*(log(sigma2.j1)+log(sigma2.j2)-log(sigma2[j])) 
			- b.sig*(1/sigma2.j1+1/sigma2.j2 - 1/sigma2[j])
		log.rv = log(prob.sm) - log.palloc - dbeta(u1,2,2,log=T) - dbeta(u2,2,2,log=T) - dbeta(u3,1,1,log=T)
		log.jacobian = log(omega[j])+log(mu.j2-mu.j1)+log(sigma2.j1)+log(sigma2.j2) 
			- (log(u2)+log(1-u2^2)+log(u3)+log(1-u3)+log(sigma2[j]))

		
if(priorK==1) {
      r = loglik.prop - loglik.pre + logterm.omega + logterm.mu + logterm.sigma + log.rv + log.jacobian + log(k+1) 
}  else  {
	r = loglik.prop - loglik.pre + logterm.omega + logterm.mu + logterm.sigma + log.rv + log.jacobian + log(lpois) 
}

		if(is.na(r)) r=-Inf
		u = runif(1)
		if(u < min(exp(r), 1))  {
			omega=omega.prop; mu=mu.prop; sigma2=sigma2.prop; z=z.prop; k=k.prop; nk=nk.prop	}
	}
	}
}


if(choose.sm==2)   {			# choose Merge move
	sel1= which(nk>0)
	if(length(sel1)==1)  { j1=sel1 }   else  { j1=sample(sel1, 1)  }
	if(j1==k) {j1=k-1; j2=k}   else  {j2=j1+1}
	
	# j1=sample(1:(k-1), 1);  j2=j1+1                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       

	omega.j = omega[j1]+omega[j2]
	mu.j = (omega[j1]*mu[j1]+omega[j2]*mu[j2])/omega.j
	sigma2.j = (omega[j1]*(mu[j1]^2+sigma2[j1])+omega[j2]*(mu[j2]^2+sigma2[j2])-omega.j*mu.j^2)/omega.j
	
	u1=omega[j1]/omega.j
	u2=(mu.j - mu[j1])/sqrt(sigma2.j)*sqrt(omega[j1]/omega[j2])
	u3=sigma2[j1]/((1-u2^2)*sigma2.j)*omega[j1]/omega.j

	if(j1==1 & k==2) {
		omega.prop=omega.j; mu.prop=mu.j; sigma2.prop=sigma2.j
		z.prop=z; z.prop[z>=j2]=z[z>=j2]-1; k.prop=k-1; nk.prop=nk[j1]+nk[j2]
	} else if(j1==1)  {
		omega.prop=c(omega.j, omega[(j2+1):k])
		mu.prop=c(mu.j, mu[(j2+1):k]); sigma2.prop=c(sigma2.j, sigma2[(j2+1):k])
		z.prop=z; z.prop[z>=j2]=z[z>=j2]-1; k.prop=k-1; nk.prop=c(nk[j1]+nk[j2], nk[(j2+1):k])
	} else if(j2==k)  {
		omega.prop=c(omega[1:(j1-1)], omega.j)
		mu.prop=c(mu[1:(j1-1)], mu.j); sigma2.prop=c(sigma2[1:(j1-1)], sigma2.j)
		z.prop=z; z.prop[z>=j2]=z[z>=j2]-1; k.prop=k-1; nk.prop=c(nk[1:(j1-1)], nk[j1]+nk[j2])
	} else  {
		omega.prop=c(omega[1:(j1-1)], omega.j, omega[(j2+1):k])
		mu.prop = c(mu[1:(j1-1)], mu.j, mu[(j2+1):k])
		sigma2.prop = c(sigma2[1:(j1-1)], sigma2.j, sigma2[(j2+1):k])
		z.prop=z; z.prop[z>=j2]=z[z>=j2]-1; k.prop=k-1; nk.prop=c(nk[1:(j1-1)], nk[j1]+nk[j2], nk[(j2+1):k])
	}

	sel = which(z==j1|z==j2); log.palloc=0
	for(i in 1:length(sel) ) {
		ci.j = as.numeric( z[sel[i]]==j2 )
		pci.j1 = omega[j1]*dnorm(x.main[sel[i]], mu[j1], sqrt(sigma2[j1]))
		pci.j2 = omega[j2]*dnorm(x.main[sel[i]], mu[j2], sqrt(sigma2[j2]))
		pci.j = pci.j2/sum(pci.j1, pci.j2)
		log.palloc = log.palloc+dbinom(ci.j, 1, prob=pci.j, log=T)
	}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
	loglik.prop = dmvnorm(x.main[sel], rep(mu.j, nk[j1]+nk[j2]), sigma2.j*diag(nk[j1]+nk[j2]), log=T)
	if(nk[j1]>0 & nk[j2]>0) {
		loglik.pre = dmvnorm(x.main[z==j1], rep(mu[j1], nk[j1]), sigma2[j1]*diag(nk[j1]), log=T) + 
			dmvnorm(x.main[z==j2], rep(mu[j2], nk[j2]), sigma2[j2]*diag(nk[j2]), log=T) 
	} else { loglik.pre = loglik.prop  }
	logterm.omega = (delta-1+nk[j1]+nk[j2])*log(omega.j)+log(beta(delta, (k-1)*delta))
		- (delta-1+nk[j1])*log(omega[j1]) - (delta-1+nk[j2])*log(omega[j2])
	logterm.mu = 1/2*(log(2*pi)-log(kappa)) - kappa/2*((mu.j-xi)^2-(mu[j1]-xi)^2-(mu[j2]-xi)^2)
	logterm.sigma = lgamma(a.sig)-a.sig*log(b.sig)-(a.sig+1)*(log(sigma2.j)-log(sigma2[j1])-log(sigma2[j2])) 
		- b.sig*(1/sigma2.j-1/sigma2[j1]-1/sigma2[j2])
	log.rv = log(prob.sm) + log.palloc + dbeta(u1,2,2,log=T) + dbeta(u2,2,2,log=T) + dbeta(u3,1,1,log=T)
	log.jacobian = log(u2)+log(1-u2^2)+log(u3)+log(1-u3)+log(sigma2.j)
		- log(omega.j)-log(mu[j2]-mu[j1])-log(sigma2[j1])-log(sigma2[j2])

if(priorK==1) {
	r = loglik.prop - loglik.pre + logterm.omega + logterm.mu + logterm.sigma + log.rv + log.jacobian - log(k)
} else {
	r = loglik.prop - loglik.pre + logterm.omega + logterm.mu + logterm.sigma + log.rv + log.jacobian - log(lpois)
}
	if(is.na(r)) r=-Inf
	u = runif(1)
	if(u < min(exp(r), 1) )  {
		omega=omega.prop; mu=mu.prop; sigma2=sigma2.prop; z=z.prop; k=k.prop; nk=nk.prop
	}

}

return( list( omega=omega, mu=mu, sigma2=sigma2, z=z, k=k, nk=nk) )

}
