update.Beta = function(y, x, bet, h.beta, beta.tilde)

{

n=length(y)

# update beta using random walk Metropolis
beta.prop = rmvnorm(1, mean=bet, sigma=diag(2))
eta.prop = beta.prop[1]+beta.prop[2]*x
log.lik.prop = sum(y*eta.prop - log(1+exp(eta.prop)))
log.post.prop = log.lik.prop + dmvnorm(beta.prop, beta.tilde, h.beta, log=T) 

eta.pre = bet[1]+bet[2]*x
log.lik.pre = sum(y*eta.pre - log(1+exp(eta.pre)))
log.post.pre = log.lik.pre + dmvnorm(bet, beta.tilde, h.beta, log=T) 

r = log.post.prop - log.post.pre; if(is.na(r)) r=-Inf
u = runif(1)

if( u < min(exp(r),1))    {     bet = beta.prop    }

return( bet )

}
