update.Tau = function(y, w, x, tau, a.tau, b.tau, AssumeScene)

{

n=length(w); gam=1/tau; e=w-x; tau.prop=rep(NA, length(tau))
if(length(tau)==1)  { tau.prop=rtnorm(1, mean=tau, sd=0.5, lower=0, upper=Inf) }  else  {
for(i in 1:length(tau)) {
	tau.prop[i] = rtnorm(1, mean=tau[i], sd=0.5, lower=0, upper=Inf)
} }
gam.prop = 1/tau.prop

if(AssumeScene==2) {
	log.lik.pre = sum(dnorm(e, 0, sqrt(abs(gam[1]+gam[2]*abs(x))), log=T))
	log.post.pre = log.lik.pre + sum(dgamma(tau, a.tau, b.tau, log=T))
	log.lik.prop = sum(dnorm(e, 0, sqrt(abs(gam.prop[1]+gam.prop[2]*abs(x))), log=T))
	log.post.prop = log.lik.prop + sum(dgamma(tau.prop, a.tau, b.tau, log=T))
} else if (AssumeScene==3) {
	log.lik.pre = sum(dnorm(e, 0, sqrt(abs(gam[1]+gam[2]*abs(x)+gam[3]*y)), log=T))
	log.post.pre = log.lik.pre + sum(dgamma(tau, a.tau, b.tau, log=T))
	log.lik.prop = sum(dnorm(e, 0, sqrt(abs(gam.prop[1]+gam.prop[2]*abs(x)+gam.prop[3]*y)), log=T))
	log.post.prop = log.lik.prop + sum(dgamma(tau.prop, a.tau, b.tau, log=T)) 
} else if (AssumeScene==4) {
	log.lik.pre = sum(dblexp(e, 1/tau, log=TRUE))
	log.post.pre = log.lik.pre + dgamma(tau, a.tau, b.tau, log=T)
	log.lik.prop = sum(dblexp(e, 1/tau.prop, log=TRUE))
	log.post.prop = log.lik.prop + dgamma(tau.prop, a.tau, b.tau, log=T)
} else if (AssumeScene %in% c(5,6)) {
	setgam1 = (e*mdchsd/mdchmean)^2
	setgam2 = (e*mdchsd/(5-mdchmean))^2
	mingam=rep(NA, n)
	mingam[sign(e)==-1] = setgam1[sign(e)==-1]
	mingam[sign(e)==1] = setgam2[sign(e)==1]
	lgam=max(mingam)
	gam.prop=rtnorm(1, mean=gam, sd=0.1, lower=1/lgam, upper=Inf) 
	tau.prop=1/gam.prop
	log.lik.pre = sum(modchi(e, 1/tau, log=TRUE))
	log.post.pre = log.lik.pre + dgamma(tau, a.tau, b.tau, log=T)
	log.lik.prop = sum(modchi(e, 1/tau.prop, log=TRUE))
	log.post.prop = log.lik.prop + dgamma(tau.prop, a.tau, b.tau, log=T)
}  else  {
	log.lik.pre = sum(dnorm(e, 0, sqrt(1/tau), log=T))
	log.post.pre = log.lik.pre + dgamma(tau, a.tau, b.tau, log=T)
	log.lik.prop = sum(dnorm(e, 0, sqrt(1/tau.prop), log=T))
	log.post.prop = log.lik.prop + dgamma(tau.prop, a.tau, b.tau, log=T)
}


r = log.post.prop - log.post.pre;  if(is.na(r)) r=-Inf
u=runif(1)
if(u < min(exp(r),1))   tau = tau.prop 

return( tau ) 

}

