rec.simD = function(n, trubet=rep(1,4), gam1=1, gam2=NULL, scene="D1")  {
# scene = "true" scenario D used to generate the data
# D1 = normal-normal homoscedastic
# D2 = normal-normal heteroscedastic
# D3 = modchi2-modchi2

# PARAMETERS FOR MODCHI2 DISTN
mdchmean = 0.8497415
mdchsd = 1.037242

if (scene=="D1")  {
   # NORMAL-NORMAL HOMOSCEDASTIC
   x1=rnorm(n,0,1); x2=rnorm(n,0,1); z=rnorm(n,0,1)
   oddrat = exp(cbind(rep(1,n),x1,x2,z)%*%trubet)
   pr = oddrat/(1+oddrat)
   y = rbinom(n,1,pr)
   e1 = rnorm(n,0,sd=sqrt(gam1)); e2=rnorm(n,0,sd=sqrt(gam1))
   w1 = x1+e1; w2=x2+e2
}

if (scene=="D2")  {
   # NORMAL-NORMAL HETEROSCEDASTI
   x1=rnorm(n,0,1); x2=rnorm(n,0,1); z=rnorm(n,0,1)
   oddrat = exp(cbind(rep(1,n),x1,x2,z)%*%trubet)
   pr = oddrat/(1+oddrat)
   y = rbinom(n,1,pr)
   condsig = sqrt(gam1+gam2*(abs(x1)+abs(x2)+abs(z)))
   e1 = rnorm(n,0,sd=condsig); e2=rnorm(n,0,sd=condsig)
   w1 = x1+e1; w2=x2+e2
}

if (scene=="D3") {
   # MODCHI-MODCHI
   sig=sqrt(gam1); z=rnorm(n,0,1)
   urv.x1 = 0.9746527*runif(n); urv.x2= 0.9746527*runif(n)
   x1 = qchisq(urv.x1,1); x1=(x1-mdchmean)/mdchsd
   x2 = qchisq(urv.x2,1); x2=(x2-mdchmean)/mdchsd
   oddrat = exp(cbind(rep(1,n),x1,x2,z)%*%trubet)
   pr = oddrat/(1+oddrat)
   y = rbinom(n,1,pr)
   urv.e1 = 0.9746527*runif(n); urv.e2= 0.9746527*runif(n)
   e1 = qchisq(urv.e1,1); e2=qchisq(urv.e2,1)
   e1 = (e1-mdchmean)/mdchsd; e2 = (e2-mdchmean)/mdchsd
   e1 = sig*e1; e2 = sig*e2
   w1 = x1+e1; w2=x2+e2
}

return(list(y=y, x=cbind(x1,x2,z), w=cbind(w1,w2)))
}
