# evaluate model log-likelihood
logLik = function(y, w1, w2, x1, x2, x3, bet, gam1, gam2, z1, z2, nk1, nk2, mu1, mu2, sigma2.1, sigma2.2, omega1, omega2, AssumeScene) 
 {
	n=length(y); x=cbind(rep(1,n), x1, x2, x3)
	pz1 = dmultinom(nk1, prob=omega1, log=T)
	pz2 = dmultinom(nk2, prob=omega2, log=T)
	eta = x%*%bet; py=sum(y*eta - log(1+exp(eta)))
	log.liki = pz1 + pz2 + py
 

if(AssumeScene=="D2") {
   for(i in 1:n) {
	px1i = dnorm(x1[i], mu1[z1[i]], sqrt(sigma2.1[z1[i]]), log=T)
	px2i = dnorm(x2[i], mu2[z2[i]], sqrt(sigma2.2[z2[i]]), log=T)
      ew1i = w1[i] - x1[i]; ew2i = w2[i] - x2[i]
	condsig = sqrt(gam1+gam2*(abs(x1[i])+abs(x2[i])+abs(x3[i])))
	pw1i = dnorm(ew1i, 0, condsig, log=T)
	pw2i = dnorm(ew2i, 0, condsig, log=T)
	log.liki = log.liki +px1i+px2i+pw1i+pw2i
   }

} else if (AssumeScene == "D3") {
   for(i in 1:n) {
	px1i = dnorm(x1[i], mu1[z1[i]], sqrt(sigma2.1[z1[i]]), log=T)
	px2i = dnorm(x2[i], mu2[z2[i]], sqrt(sigma2.2[z2[i]]), log=T)
      ew1i = w1[i] - x1[i]; ew2i = w2[i] - x2[i]
	pw1i = modchi(ew1i, gam1, log=TRUE)
	pw2i = modchi(ew2i, gam1, log=TRUE)
	log.liki = log.liki +  px1i+px2i+pw1i+pw2i
   }

}  else  {
   for(i in 1:n) {
	px1i = dnorm(x1[i], mu1[z1[i]], sqrt(sigma2.1[z1[i]]), log=T)
	px2i = dnorm(x2[i], mu2[z2[i]], sqrt(sigma2.2[z2[i]]), log=T)
      ew1i = w1[i] - x1[i]; ew2i = w2[i] - x2[i]
	pw1i = dnorm(ew1i, 0, sqrt(gam1), log=T)
	pw2i = dnorm(ew2i, 0, sqrt(gam1), log=T)
	log.liki = log.liki + px1i+px2i+pw1i+pw2i
   }

}

return( log.liki ) 

}
