main.fun = function(y, w1, w2, x3, x1, x2, beta.tilde, h.beta, xi1, xi2, gam1, gam2, 
	kappa1, kapp2, a.sig, g.sig, h1.sig, h2.sig, delta, Kmax, bet, omega1, omega2, 
	z1, z2, nk1, nk2, k1, k2, b1.sig, b2.sig, priorK, lpois, AssumeScene) 


# main function implementing measurement error model of 
{

n=length(y)

for(iter in 1:T) {

# update beta
bet = update.Beta(y, x1, x2, x3, bet, h.beta, beta.tilde)

# update each x_i, i=1,...,n.main, using random walk Metropolis
x = update.X(y, w1, w2, x1, x2, x3, bet, gam1, gam2, z1, z2, mu1, mu2, sigma2.1, sigma2.2, AssumeScene)
x1=x[,1]; x2=x[,2]

# update omega1, mu1, sigma2.1, b1.sig, z1 
upd.omsbc1 = update.OMuSigBC(k1, z1, nk1, n, x1, omega1, mu1, sigma2.1, kappa1, xi1, 
	a.sig, g.sig, h1.sig, b1.sig, delta)  
omega1=upd.omsbc1$omega; mu1=upd.omsbc1$mu; sigma2.1=upd.omsbc1$sigma2;
b1.sig=upd.omsbc1$b.sig; z1=upd.omsbc1$z; nk1=upd.omsbc1$nk

# update omega2, mu2, sigma2.2, b2.sig, z2 
upd.omsbc2 = update.OMuSigBC(k2, z2, nk2, n, x2, omega2, mu2, sigma2.2, kappa2, xi2, 
	a.sig, g.sig, h2.sig, b2.sig, delta)  
omega2=upd.omsbc2$omega; mu2=upd.omsbc2$mu; sigma2.2=upd.omsbc2$sigma2;
b2.sig=upd.omsbc2$b.sig; z2=upd.omsbc2$z; nk2=upd.omsbc2$nk


# update K and mixture parameters using RJMCMC for X1
upd.ksm1 = rjmcmcSM(omega1, mu1, sigma2.1, z1, x1, nk1, k1, Kmax, delta, a.sig, b1.sig, kappa1, xi1, priorK, lpois) 
omega1=upd.ksm1$omega; mu1=upd.ksm1$mu; sigma2.1=upd.ksm1$sigma2; z1=upd.ksm1$z; k1=upd.ksm1$k; nk1=upd.ksm1$nk

# update K and mixture parameters using RJMCMC for X2
upd.ksm2 = rjmcmcSM(omega2, mu2, sigma2.2, z2, x2, nk2, k2, Kmax, delta, a.sig, b2.sig, kappa2, xi2, priorK, lpois) 
omega2=upd.ksm2$omega; mu2=upd.ksm2$mu; sigma2.2=upd.ksm2$sigma2; z2=upd.ksm2$z; k2=upd.ksm2$k; nk2=upd.ksm2$nk


# create/delete empty components using RJMCMC for X1
upd.kbd1 = rjmcmcBD(omega1, mu1, sigma2.1, z1, nk1, k1, Kmax, delta, xi1, kappa1, a.sig, b1.sig, priorK, lpois) 
omega1=upd.kbd1$omega; mu1=upd.kbd1$mu; sigma2.1=upd.kbd1$sigma2; z1=upd.kbd1$z; k1=upd.kbd1$k; nk1=upd.kbd1$nk

# create/delete empty components using RJMCMC for X2
upd.kbd2 = rjmcmcBD(omega2, mu2, sigma2.2, z2, nk2, k2, Kmax, delta, xi2, kappa2, a.sig, b2.sig, priorK, lpois) 
omega2=upd.kbd2$omega; mu2=upd.kbd2$mu; sigma2.2=upd.kbd2$sigma2; z2=upd.kbd2$z; k2=upd.kbd2$k; nk2=upd.kbd2$nk


# log-posterior probability of visited model

log.lik.all = logLik(y, w1, w2, x1, x2, x3, bet, gam1, gam2, z1, z2, nk1, nk2, 
	mu1, mu2, sigma2.1, sigma2.2, omega1, omega2, AssumeScene) 
log.param = sum(dnorm(mu1, xi1, sqrt(1/kappa1), log=T)) + sum(dnorm(mu2, xi2, sqrt(1/kappa2), log=T)) + 
	sum(dgamma(1/sigma2.1, a.sig, b1.sig, log=T)) + sum(dgamma(1/sigma2.2, a.sig, b2.sig, log=T)) + 
	logddir(omega1, rep(delta,k1)) + logddir(omega2, rep(delta,k2)) + 
	dmvnorm(bet, beta.tilde, h.beta, log=T) + 
	dgamma(b1.sig, g.sig, h1.sig, log=T) + dgamma(b2.sig, g.sig, h2.sig, log=T)

if(priorK==1) {
	logkpr = -2*log(Kmax-1)
}  else  {
	logkpr = dpois(k1,lpois,log=T) + dpois(k2,lpois,log=T) - 2*(log(ppois(Kmax,lpois)-dpois(0,lpois)))
}

LogPost[iter] = logkpr + log.param + log.lik.all 
	

X1[iter,]=x1; X2[iter,]=x2; Z1[iter,]=z1; Z2[iter,]=z2 
Beta[iter,] = bet; Bsig1[iter]=b1.sig; Bsig2[iter]=b2.sig
K1[iter,]=c(k1, length(which(nk1>0)), length(which(nk1==0))); 
K2[iter,]=c(k2, length(which(nk2>0)), length(which(nk2==0))); 
Nk1[[iter]]=nk1; Nk2[[iter]]=nk2; Omega1[[iter]]=omega1; Omega2[[iter]]=omega2;
Mu1[[iter]]=mu1; Mu2[[iter]]=mu2; Sigma2.1[[iter]]=sigma2.1; Sigma2.2[[iter]]=sigma2.2
}

return( list(Beta=Beta, X1=X1, X2=X2, Z1=Z1, Z2=Z2, K1=K1, K2=K2, Nk1=Nk1, Nk2=Nk2,
	Omega1=Omega1, Omega2=Omega2, Mu1=Mu1, Mu2=Mu2, Sigma2.1=Sigma2.1, Sigma2.2=Sigma2.2, 
	Bsig1=Bsig1, Bsig2=Bsig2, LogPost=LogPost))
}

