rjmcmcBD = function(omega, mu, sigma2, z, nk, k, Kmax, delta, xi, kappa, a.sig, b.sig, priorK, lpois) 

{

n=sum(nk)

# Birth/Death move
k0 = length(which(nk==0)); choose.bd=0	# number of empty components
if(k0==0 & k < Kmax)   {  # can only create empty component
	choose.bd = 1; p.birth=1; p.death=0 ; 
	if(k==Kmax-1) { prob.bd=1}  else { prob.bd=0.5 }
}	else if(k0>0 & k==Kmax)  {  # can only delete empty component
	choose.bd=2; p.birth=0; p.death=1; 
	if(k0==1)  { prob.bd=1 }  else { prob.bd = 0.5 }
}	else if (k0>0 & k<Kmax)  { 
	choose.bd = sample(1:2, 1); p.birth = p.death = 0.5 
	if((k0==1 & choose.bd==2) | (k==Kmax-1 & choose.bd==1)) { prob.bd = 2 } else  { prob.bd = 1  }
}

if(choose.bd==1)   {			# choose Birth move
	omeganew=rbeta(1,1,k); munew=rnorm(1,xi,sqrt(1/kappa)); sigma2new=1/rgamma(1,a.sig,b.sig)

	if(munew < min(mu)) {
		omega.prop = c(omeganew, omega); mu.prop = c(munew, mu); sigma2.prop = c(sigma2new, sigma2)
		z.prop = z+1; k.prop = k+1; nk.prop=c(0, nk)
	}  else if (munew > max(mu))  {
		omega.prop = c(omega, omeganew); mu.prop = c(mu, munew); sigma2.prop = c(sigma2, sigma2new)
		z.prop = z; k.prop = k+1; nk.prop=c(nk, 0)
	}  else {
		j = max(which(mu<munew))
		omega.prop=c(omega[1:j]/(1-omeganew), omeganew, omega[(j+1):k]/(1-omeganew))
		mu.prop=c(mu[1:j], munew, mu[(j+1):k]); sigma2.prop=c(sigma2[1:j], sigma2new, sigma2[(j+1):k]); 
		z.prop=z; z.prop[z>j]=z[z>j]+1; k.prop=k+1; nk.prop=c(nk[1:j], 0, nk[(j+1):k])
	}

	logterm.omega = (delta-1)*log(omeganew)+(n+k*(delta-1))*log(1-omeganew)-log(beta(k*delta,delta))
	log.rvjac = log(prob.bd) - log(k0+1) - dbeta(omeganew,1,k,log=T) + (k-1)*log(1-omeganew)
		
	if(priorK==1) {
		r = logterm.omega + log.rvjac +log(k+1)
	} else {
		r = logterm.omega + log.rvjac +log(lpois) }

	if(is.na(r)) r=-Inf
	u = runif(1)
	if(u < min(exp(r), 1))  {
		omega=omega.prop; mu=mu.prop; sigma2=sigma2.prop; z=z.prop; k=k.prop; nk=nk.prop  	}
}

if(choose.bd==2)   {			# choose Death move
	sel0=which(nk==0)
	if(length(sel0)==1) j=sel0  else  j=sample(sel0,1)
	omega.prop = omega[-j]/(1-omega[j]); mu.prop=mu[-j]; sigma2.prop=sigma2[-j]
	k.prop=k-1; nk.prop=nk[-j]
	if(j==k) { z.prop=z }  else { z.prop=z; z.prop[z>j]=z[z>j]-1 }

	logterm.omega = log(beta((k-1)*delta,delta))-(delta-1)*log(omega[j])-(n+(k-1)*(delta-1))*log(1-omega[j])
	log.rvjac = log(prob.bd) + log(k0) + dbeta(omega[j],1,k-1,log=T) - (k-2)*log(1-omega[j])
	
	if(priorK==1) {	
		r = logterm.omega + log.rvjac - log(k)
	} else {
		r = logterm.omega + log.rvjac - log(lpois) }

	if(is.na(r)) r=-Inf  
	u = runif(1)
	if(u < min(exp(r), 1))  {
		omega=omega.prop; mu=mu.prop; sigma2=sigma2.prop; z=z.prop; k=k.prop; nk=nk.prop	}
}
	
return( list( omega=omega, mu=mu, sigma2=sigma2, z=z, k=k, nk=nk) )

}

