update.Beta = function(y, x1, x2, x3, bet, h.beta, beta.tilde)

{

n=length(y); x=cbind(rep(1,n), x1, x2, x3); D=length(bet)

# update each beta using random walk Metropolis
# beta.prop = as.vector(rmvnorm(1, mean=bet, sigma=diag(d)))
d=sample(1:D, 1)
beta.prop = bet; beta.prop[d] = rnorm(1, mean=bet[d], sd=1)
eta.prop = x%*%beta.prop
log.lik.prop = sum(y*eta.prop - log(1+exp(eta.prop)))
log.post.prop = log.lik.prop + dmvnorm(beta.prop, beta.tilde, h.beta, log=T) 

eta.pre = x%*%bet
log.lik.pre = sum(y*eta.pre - log(1+exp(eta.pre)))
log.post.pre = log.lik.pre + dmvnorm(bet, beta.tilde, h.beta, log=T) 

r = log.post.prop - log.post.pre; if(is.na(r)) r=-Inf
u = runif(1)

if( u < min(exp(r),1))    {     bet = beta.prop    }

return( bet )

}
