update.OMuSigBC = function(k, z, nk, n, x, omega, mu, sigma2, kappa, xi, a.sig, g.sig, h.sig, b.sig, delta)  

{

# update omega
omega = rdirichlet(1, nk+delta)

# update each mu_j, j=1,...,k 
for(j in 1:k) {
	if(nk[j]==0) { mu.prop=rnorm(1, xi, 1/sqrt(kappa))  }  else 
	{	meanmu = (sum(x[z==j])/sigma2[j] + kappa*xi)/(nk[j]/sigma2[j]+kappa) 
		varmu = 1/(nk[j]/sigma2[j]+kappa)
		mu.prop = rnorm(1, meanmu, sqrt(varmu))  }

	if(j==1 & k==1) { 
		mu[j]=mu.prop  
	} else if(j==1 & j<k) {
		if(mu.prop < mu[j+1]) mu[j]=mu.prop
	}  else if(j>1 & j==k) {
		if(mu.prop > mu[j-1]) mu[j]=mu.prop
	}  else if(j>1 & j<k) {
		if(mu.prop > mu[j-1] & mu.prop < mu[j+1])  mu[j]=mu.prop  
	}
}

# update each sigma2_j, j=1,...,k
for(j in 1:k)  {
	if(nk[j]==0) { sigma2[j] = 1/rgamma(1, a.sig, b.sig) }  else { 
	sigma2[j] = 1/rgamma(1, a.sig+nk[j]/2, b.sig+sum((x[z==j]-mu[j])^2)/2) }
}

# update b.sig
b.sig = rgamma(1, g.sig+k*a.sig, h.sig+sum(1/sigma2) )

# update each z_i, i=1,...,n
for(i in 1:n) {
	pci = rep(NA, k) 
	for(j in 1:k)  {
		pci[j] = omega[j]*dnorm(x[i], mu[j], sqrt(sigma2[j]))
	}
	pci = pci/sum(pci)
	z[i] = which(rmultinomial(1,1,pci)!=0)
}

nk.upd=clusize(z,k)

return( list(omega=omega, mu=mu, sigma2=sigma2, b.sig=b.sig, z=z, nk=nk.upd) )
}
