main.fun = function(y, w, x, beta.tilde, h.beta, xi, kappa, a.sig, g.sig, h.sig, delta, Kmax, bet, tau, omega, z, nk, k, b.sig, priorK, lpois, AssumeScene)  

# main function implementing measurement error model of 
{

n=length(y); 

for(iter in 1:T) {

# update beta
bet = update.Beta(y, x, bet, h.beta, beta.tilde)

# update each x_i, i=1,...,n.main, using random walk Metropolis
x = update.X(y, w, x, bet, tau, z, mu, sigma2, AssumeScene)

# update omega, mu, sigma2, b.sig, z 
upd.omsbc = update.OMuSigBC(k, z, nk, n, x, omega, mu, sigma2, kappa, xi, a.sig, g.sig, h.sig, b.sig, delta)  
omega=upd.omsbc$omega; mu=upd.omsbc$mu; sigma2=upd.omsbc$sigma2;
b.sig=upd.omsbc$b.sig; z=upd.omsbc$z; nk=upd.omsbc$nk


# update K and mixture parameters using RJMCMC
upd.ksm = rjmcmcSM(omega, mu, sigma2, z, x, nk, k, Kmax, delta, a.sig, b.sig, kappa, xi, priorK, lpois) 
omega=upd.ksm$omega; mu=upd.ksm$mu; sigma2=upd.ksm$sigma2; z=upd.ksm$z; k=upd.ksm$k; nk=upd.ksm$nk


# create/delete empty components using RJMCMC
upd.kbd = rjmcmcBD(omega, mu, sigma2, z, nk, k, Kmax, delta, priorK, lpois) 
omega=upd.kbd$omega; mu=upd.kbd$mu; sigma2=upd.kbd$sigma2; z=upd.kbd$z; k=upd.kbd$k; nk=upd.kbd$nk


X[iter,]=x; Z[iter,]=z; 
Beta[iter,] = bet; Bsig[iter]=b.sig;
K[iter,]=c(k, length(which(nk>0)), length(which(nk==0))); 
Nk[[iter]]=nk; Omega[[iter]]=omega; Mu[[iter]]=mu; Sigma2[[iter]]=sigma2
}

return( list(Beta=Beta, X=X, Z=Z, K=K, Nk=Nk, Omega=Omega, Mu=Mu, Sigma2=Sigma2, Bsig=Bsig))
}

