C      SUBROUTINE TO COMPUTE DELTA
       subroutine delcmp(b,n,p,pz,r,kk2,pkk1,pkk2,y,z,
     $   digmatpkk2,nodes2,cdwt,wwvec,del)

       implicit double precision (a-h,o-z)
       integer p, pz, r, pkk1, pkk2

       dimension b(r), y(n), z(n,pz)
       dimension covvec(r), gscore(r), del(n,r,pkk2)
       dimension cdwt(n,pkk2,pkk1), wwvec(n,pkk2,pkk1,p)
       double precision nodes2(kk2)
       integer digmatpkk2(pkk2,p)

       del = 0.0d0

       do i = 1, n

C        SETUPS
         yval = y(i)
         covvec(1) = 1.0d0
         do ipz = 1, pz
           covvec(1+p+ipz) = z(i,ipz)
          enddo

C        DELTA
         do is = 1, pkk2
           do ip = 1, p
             idxs = digmatpkk2(is,ip)
             covvec(1+ip) = nodes2(idxs)
            enddo
           call glmscore(yval,r,covvec,b,gscore)
           do ir = 1, r
             del(i,ir,is) = del(i,ir,is) + gscore(ir)
            enddo
           do k = 1, pkk1
             do ip = 1, p
               covvec(1+ip) = wwvec(i,is,k,ip)
              enddo
             call glmscore(yval,r,covvec,b,gscore)
             do ir = 1, r
               del(i,ir,is) = del(i,ir,is) - cdwt(i,is,k)*gscore(ir)
              enddo
            enddo
          enddo

        enddo

       return
       end

C******************************************************************************

C      SUBROUTINE TO COMPUTE GLMSCORE
       subroutine glmscore(yval,r,covvec,b,scorvec)
       implicit double precision(a-h, o-z)
       integer r
       dimension b(r), covvec(r), scorvec(r)
       eta = 0.0d0
       do ir = 1, r
         eta = eta + b(ir)*covvec(ir)
        enddo
       orat = dexp(eta)
       emu = orat/(1.0d0+orat)
       diff = yval - emu
       do ir = 1, r
         scorvec(ir) = diff*covvec(ir)
        enddo
       return
       end

C******************************************************************************
