       subroutine scoresoln(b0,n,p,pz,r,pdfr,kk2,pkk1,pkk2,
     $   y,w,z,cmi,psiw,digmatpkk2,nodes2,cdwt,wwvec,xtol,
     $   ftol,b,igood)

       implicit double precision (a-h,o-z)
       integer p, pz, r, pdfr, pkk1, kk2, pkk2
       external scfn

       dimension b0(r), b(r), y(n), w(n,p), z(n,pz)
       dimension scor(r), scjac(r,r), diag(r), rmat(100), qtf(r)
       dimension wa1(r), wa2(r), wa3(r), wa4(r)
       dimension cmi(n,pdfr,pkk2), psiw(n,pdfr)
       dimension cdwt(n,pkk2,pkk1), wwvec(n,pkk2,pkk1,p)
       double precision nodes2(kk2)
       integer digmatpkk2(pkk2,p)

       igood = 1
       b = b0
       maxfev = 200
       mode = 1
       factor = 100.0d0
       nprint = -1
       lr = 100
       nn = n
       call hybrj(scfn,r,b,scor,scjac,r,xtol,maxfev,diag,
     $  mode,factor,nprint,info,nfev,njev,rmat,lr,qtf,
     $  wa1,wa2,wa3,wa4,nn,p,pz,pdfr,kk2,pkk1,pkk2,
     $  y,w,z,cmi,psiw,digmatpkk2,nodes2,cdwt,wwvec)
       if (info .ne. 1) igood=0
       scormax = 0.0d0
       do ir = 1, r
         scr = dabs(scor(ir))
         if (scr .gt. scormax) scormax=scr
        enddo
       if (scormax .gt. ftol) igood=0

       return
       end

C******************************************************************************

      subroutine scfn(r,b,scor,scjac,ldfjac,iflag,n,p,pz,
     $  pdfr,kk2,pkk1,pkk2,y,w,z,cmi,psiw,digmatpkk2,nodes2,
     $  cdwt,wwvec)

       implicit double precision (a-h, o-z)
       integer p, pz, r, pdfr, pkk1, kk2, pkk2

       dimension b(r), scor(r), scjac(r,r)
       dimension y(n), w(n,p), z(n,pz)
       dimension cmi(n,pdfr,pkk2), psiw(n,pdfr)
       dimension cdwt(n,pkk2,pkk1), wwvec(n,pkk2,pkk1,p)
       dimension covvec(r), scnai(r), djnai(r,r)
       dimension gscore(r), gjac(r,r)
       dimension del(pkk2,r), delj(pkk2,r,r)
       dimension dmat1(pdfr,r), dmat2(pdfr,r,r)
       double precision nodes2(kk2)
       integer digmatpkk2(pkk2,p)

       if (iflag .eq. 1) scor = 0.0d0
       if (iflag .eq. 2) scjac = 0.0d0

       do i = 1, n

C        SETUPS
         yval = y(i)
         covvec(1) = 1.0d0
         do ip = 1, p
           covvec(1+ip) = w(i,ip)
          enddo
         do ipz = 1, pz
           covvec(1+p+ipz) = z(i,ipz)
          enddo

C        NAIVE SCORE
         call glmscore(yval,r,covvec,b,scnai,djnai,iflag)
         if (iflag .eq. 1)
     $     then
             do ir = 1, r
               scor(ir) = scor(ir) + scnai(ir)
              enddo
           else
             do ir1 = 1, r
             do ir2 = 1, r
               scjac(ir1,ir2) = scjac(ir1,ir2) + djnai(ir1,ir2)
              enddo
              enddo
          endif

C        COMPUTE DEL VECTOR OR JACOBIAN
         del = 0.0d0
         delj = 0.0d0
         do is = 1, pkk2
           do ip = 1, p
             idxs = digmatpkk2(is,ip)
             covvec(1+ip) = nodes2(idxs)
            enddo
           call glmscore(yval,r,covvec,b,gscore,gjac,iflag)
           if (iflag .eq. 1)
     $         then
                 do ir = 1, r
                   del(is,ir) = gscore(ir)
                 enddo
               else
                 do ir1 = 1, r
                 do ir2 = 1, r
                   delj(is,ir1,ir2) = gjac(ir1,ir2)
                 enddo
                 enddo
              endif
           do k = 1, pkk1
             do ip = 1, p
               covvec(1+ip) = wwvec(i,is,k,ip)
              enddo
             wt = cdwt(i,is,k)
             call glmscore(yval,r,covvec,b,gscore,gjac,iflag)
             if (iflag .eq. 1)
     $         then
                 do ir = 1, r
                   del(is,ir) = del(is,ir) - wt*gscore(ir)
                 enddo
               else
                 do ir1 = 1, r
                   do ir2 = 1, r
                     trm = wt*gjac(ir1,ir2)
                     delj(is,ir1,ir2) = delj(is,ir1,ir2) - trm
                   enddo
                   enddo
                endif
            enddo
          enddo

C        COMPUTE CORRECTED SCORE VECTOR OR JACOBIAN
         if (iflag .eq. 1)
     $     then
C            COMPUTE SCORE VECTOR
             do is1 = 1, pdfr
             do ir = 1, r
               dmat1(is1,ir) = 0.0d0
               do is2 = 1, pkk2
                 trm = cmi(i,is1,is2)*del(is2,ir)
                 dmat1(is1,ir) = dmat1(is1,ir) + trm
                enddo
              enddo
              enddo
             do ir = 1, r
               DeltaBar = 0.0d0
               do is = 1, pdfr
                 DeltaBar = DeltaBar + psiw(i,is)*dmat1(is,ir)
                enddo
               scor(ir) = scor(ir) + DeltaBar
              enddo
           else
C            COMPUTE JACOBIAN
             do is1 = 1, pdfr
             do ir1 = 1, r
             do ir2 = 1, r
               dmat2(is1,ir1,ir2) = 0.0d0
               do is2 = 1, pkk2
                 trm = cmi(i,is1,is2)*delj(is2,ir1,ir2)
                 dmat2(is1,ir1,ir2) = dmat2(is1,ir1,ir2) + trm
                enddo
              enddo
              enddo
              enddo
             do ir1 = 1, r
             do ir2 = 1, r
               DeltaBar = 0.0d0
               do is = 1, pdfr
                 DeltaBar = DeltaBar + psiw(i,is)*dmat2(is,ir1,ir2)
                enddo
               scjac(ir1,ir2) = scjac(ir1,ir2) + DeltaBar
              enddo
              enddo
          endif

        enddo

       return
       end

C******************************************************************************

C      SUBROUTINE TO COMPUTE GLMSCORE
       subroutine glmscore(yval,r,covvec,b,scorvec,djacmat,iflag)
       implicit double precision(a-h, o-z)
       integer r
       dimension b(r), covvec(r), scorvec(r), djacmat(r,r)
       eta = 0.0d0
       do ir = 1, r
         eta = eta + b(ir)*covvec(ir)
        enddo
       orat = dexp(eta)
       emu = orat/(1.0d0+orat)
       diff = yval - emu
       if (iflag .eq. 1)
     $   then
           do ir = 1, r
             scorvec(ir) = diff*covvec(ir)
            enddo
         else
           do ir1 = 1, r
           do ir2 = 1, r
             djacmat(ir1,ir2) = emu*(1.0d0-emu)*covvec(ir1)*covvec(ir2)
            enddo
            enddo
        endif
       return
       end

C******************************************************************************
C******************************************************************************
C
C       END OF MAIN SUBROUTINES
C       THE REST ARE UTILITY SUBROUTINES, AS FOLLOWS
C       hybrj: solve a nonlinear system via Powell's hybrid method
C       the rest (dogleg, dpmpar, enorm, qform,qrfac,r1mpyq,r1updt):
C         minpack routines used in hybrj

        include "hybrj.f"
