C      SUBROUTINE TO SET UP VARIOUS QUANTITIES FOR RECS COMPUTATION
       subroutine setup(iscen,n,p,npxi,dfr,pdfr,kk1,pkk1,kk2,pkk2,
     $   y,w,z,xi,digmatpdfr,digmatpkk1,digmatpkk2,nodes1,qv1,nodes2,
     $   wscal,coefmat,psiw,phi,cdwt,wwvec)

       implicit double precision (a-h,o-z)
       integer p, npxi, dfr, pdfr, kk1, pkk1, kk2, pkk2

       dimension y(n), w(n,p), z(n), xi(npxi)
       dimension xx(p), ww(p), wscal(p), sigerr(p)
       dimension psiw(n,pdfr), psiw0(p,dfr), coefmat(dfr,dfr)
       dimension cdwt(n,pkk2,pkk1), wwvec(n,pkk2,pkk1,p)
       dimension phi(n,pkk2,pdfr), pprd(p,dfr)
       double precision nodes1(kk1), qv1(kk1), nodes2(kk2)
       integer digmatpdfr(pdfr,p)
       integer digmatpkk1(pkk1,p), digmatpkk2(pkk2,p)

C      PSIW MATRIX
       psiw = 0.0d0
       do i = 1, n
         psiw0 = 0.0d0
         do ip = 1, p
         do m1 = 1, dfr
         do m2 = 1, dfr
           trm = coefmat(m1,m2) * (w(i,ip)**(m2-1))
           psiw0(ip,m1) = psiw0(ip,m1) + trm
          enddo
          enddo
          enddo
         do m = 1, pdfr
           ptrm = 1.0d0
           do ie = 1, p
             idxm = digmatpdfr(m,ie)
             psf = psiw0(ie,idxm)
             ptrm = ptrm*psf
            enddo
           psiw(i,m) = ptrm
          enddo
        enddo

C      WWVEC AND CDWT MATRICES
       do i = 1, n
         yval = y(i)
         zval = z(i)
         do j = 1, pkk2
           do ip = 1, p
             idxj = digmatpkk2(j,ip)
             xx(ip) = nodes2(idxj)
            enddo
           call sigcmp(iscen,p,npxi,xx,zval,yval,xi,wscal,sigerr)
           do l = 1, pkk1
             qvfl = 1.0d0
             do ip = 1, p
               idxl = digmatpkk1(l,ip)
               qvfl = qvfl*qv1(idxl)
               ww(ip) = xx(ip) + sigerr(ip)*nodes1(idxl)
               wwvec(i,j,l,ip) = ww(ip)
              enddo
             cdwt(i,j,l) = qvfl
            enddo
          enddo
        enddo

C      PHI MATRIX
       phi = 0.0d0
       do i = 1, n
       do j = 1, pkk2
       do l = 1, pkk1
         pprd = 0.0d0
         do ip = 1, p
           do id = 1, dfr
             do ipow = 1, dfr
               ipwr = ipow-1
               trm = coefmat(id,ipow)*(wwvec(i,j,l,ip)**ipwr)
               pprd(ip,id) = pprd(ip,id) + trm
              enddo
            enddo
          enddo
         do im = 1, pdfr
           prtrm = 1.0d0
           do ip = 1, p
             idxm = digmatpdfr(im,ip)
             prtrm = prtrm * pprd(ip,idxm)
            enddo
           phi(i,j,im) = phi(i,j,im) + cdwt(i,j,l)*prtrm
          enddo
        enddo
        enddo
        enddo

       return
       end

C******************************************************************************
C
C      STD DEVIATION ROUTINE
       subroutine sigcmp(iscen,p,npxi,xx,zval,yval,xi,wscal,sigerr)
       implicit double precision (a-h, o-z)
       integer p, npxi
       dimension xx(p), xi(npxi), wscal(p), sigerr(p)
       if ((iscen .eq. 1) .or. (iscen .eq. 3)) then
         sige = dsqrt(xi(1))
         sigerr(1) = wscal(1)*sige
         sigerr(2) = wscal(2)*sige
        endif
       if (iscen .eq. 2) then
         vtrm = dabs(xx(1)/wscal(1))+dabs(xx(2)/wscal(2))+dabs(zval)
         var = xi(1) + xi(2)*vtrm
         sige = dsqrt(var)
         sigerr(1) = wscal(1)*sige
         sigerr(2) = wscal(2)*sige
        endif
       return
       end

C******************************************************************************
