C      SUBROUTINE TO COMPUTE RECS SCORE FUNCTION
       subroutine scorefn(b,n,p,pz,r,pdfr,kk2,pkk1,pkk2,y,w,z,
     $   cmi,psiw,digmatpkk2,nodes2,cdwt,wwvec,umat)

       implicit double precision (a-h,o-z)
       integer p, pz, r, pdfr, pkk1, kk2, pkk2

       dimension b(r), y(n), w(n,p), z(n,pz)
       dimension cmi(n,pdfr,pkk2), psiw(n,pdfr)
       dimension covvec(r), scnai(r), gscore(r), umat(n,r)
       dimension cdwt(n,pkk2,pkk1), wwvec(n,pkk2,pkk1,p)
       dimension del(pkk2,r), dmat(pdfr,r)
       double precision nodes2(kk2)
       integer digmatpkk2(pkk2,p)

       umat = 0.0d0

       do i = 1, n

C        SETUPS
         yval = y(i)
         covvec(1) = 1.0d0
         do ip = 1, p
           covvec(1+ip) = w(i,ip)
          enddo
         do ipz = 1, pz
           covvec(1+p+ipz) = z(i,ipz)
          enddo

C        NAIVE SCORE U
         call glmscore(yval,r,covvec,b,scnai)

C        DELTA
         del = 0.0d0
         do is = 1, pkk2
           do ip = 1, p
             idxs = digmatpkk2(is,ip)
             covvec(1+ip) = nodes2(idxs)
            enddo
           call glmscore(yval,r,covvec,b,gscore,gjac,iflag)
           do ir = 1, r
             del(is,ir) = gscore(ir)
            enddo
           do k = 1, pkk1
             do ip = 1, p
               covvec(1+ip) = wwvec(i,is,k,ip)
              enddo
             wt = cdwt(i,is,k)
             call glmscore(yval,r,covvec,b,gscore,gjac,iflag)
             do ir = 1, r
                del(is,ir) = del(is,ir) - wt*gscore(ir)
              enddo
            enddo
          enddo

C        COMPUTE CORRECTED SCORE
         do is1 = 1, pdfr
         do ir = 1, r
           dmat(is1,ir) = 0.0d0
           do is2 = 1, pkk2
             dmat(is1,ir) = dmat(is1,ir) + cmi(i,is1,is2)*del(is2,ir)
            enddo
          enddo
          enddo
         do ir = 1, r
           DeltaBar = 0.0d0
           do is = 1, pdfr
             DeltaBar = DeltaBar + psiw(i,is)*dmat(is,ir)
            enddo
           umat(i,ir) = scnai(ir) + DeltaBar
          enddo

        enddo

       return
       end

C******************************************************************************

C      SUBROUTINE TO COMPUTE GLMSCORE
       subroutine glmscore(yval,r,covvec,b,scorvec)
       implicit double precision(a-h, o-z)
       integer r
       dimension b(r), covvec(r), scorvec(r)
       eta = 0.0d0
       do ir = 1, r
         eta = eta + b(ir)*covvec(ir)
        enddo
       orat = dexp(eta)
       emu = orat/(1.0d0+orat)
       diff = yval - emu
       do ir = 1, r
         scorvec(ir) = diff*covvec(ir)
        enddo
       return
       end

C******************************************************************************
